SUBROUTINE k_correle(T_mid, P_mid, Q_mid, n_v, n_c, n_o ,Dz, iT, iP, iQ, &
     Tarr, Parr, Qarr, garr, kdist, tau_b)

  implicit none

  integer, parameter ::  Nq=16
  integer :: jT,jP,jQ
  double precision :: a_T, a_P, a_Q, col_dens, kdist_int
  double precision :: Tmid, Pmid, Qmid

  ! IN/OUT
  double precision, intent(in) :: T_mid, P_mid, Q_mid, n_v, n_c, n_o
  double precision, intent(in) :: Dz
  integer, intent(in) :: iT, iP, iQ
  real, dimension(iT), intent(in) :: Tarr
  real, dimension(iP), intent(in) :: Parr
  real, dimension(iQ), intent(in) :: Qarr
  real, dimension(Nq), intent(in) :: garr
  double precision, dimension(iT,iP,iQ) :: kdist

  double precision, intent(out) :: tau_b

  !!!!!
  col_dens = (n_v+n_c+n_o)*Dz*1d2

  ! copie Tmid,Pmid,Qmid pour ne pas alterer input
  Tmid = T_mid
  Pmid = P_mid
  Qmid = Q_mid

  ! protection over/under flow
  Tmid = dmax1(Tmid,51d0)
  Tmid = dmin1(Tmid,699d0)

  Pmid = dmax1(Pmid,1.1d0)
  Pmid = dmin1(Pmid,9.9d6)

  Qmid = dmax1(Qmid,1.1d-9)
  Qmid = dmin1(Qmid,9.998d-1)

  jT = iT
  DO WHILE (Tarr(jT) > Tmid)
     jT = jT-1
  END DO
  a_T = (1./Tmid - 1./Tarr(jT+1))/(1./Tarr(jT)-1./Tarr(jT+1))

  jP = iP
  DO WHILE (Parr(jP) < dlog10(Pmid))
     jP = jP-1
  END DO
  
  a_P = (dlog10(Pmid)-Parr(jP+1))/(Parr(jP)-Parr(jP+1))

  jQ = iQ
  DO WHILE (Qarr(jQ) < Qmid)
     jQ = jQ-1
  END DO

  a_Q = (dlog10(Qmid)-log10(Qarr(jQ+1)))/(log10(Qarr(jQ))-log10(Qarr(jQ+1)))

  tau_b = 0d0

  kdist_int =                   a_T*a_P*a_Q*dlog10(kdist(jT,jP,jQ))+     &
                          a_T*a_P*(1d0-a_Q)*dlog10(kdist(jT,jP,jQ+1))+   &
                          a_T*(1d0-a_P)*a_Q*dlog10(kdist(jT,jP+1,jQ))+   &
                    a_T*(1d0-a_P)*(1d0-a_Q)*dlog10(kdist(jT,jP+1,jQ+1))+ &
                          (1d0-a_T)*a_P*a_Q*dlog10(kdist(jT+1,jP,jQ))+   &
                    (1d0-a_T)*a_P*(1d0-a_Q)*dlog10(kdist(jT+1,jP,jQ+1))+ &
                    (1d0-a_T)*(1d0-a_P)*a_Q*dlog10(kdist(jT+1,jP+1,jQ))+ &
              (1d0-a_T)*(1d0-a_P)*(1d0-a_Q)*dlog10(kdist(jT+1,jP+1,jQ+1))

  kdist_int = 1d1**kdist_int

  tau_b = col_dens*kdist_int

END SUBROUTINE k_correle
